library(tidyverse)
library(readxl)

#importing data
raw_rCBV <- read_excel("data/BVf_isocortexNATIVE.xlsx", sheet = "isocortex_right")
Group_assignment <- read_excel("data/groups.xlsx",col_names = TRUE)

#cleaning rCBV data from M19 and merge data
final <- raw_rCBV %>%
  inner_join(Group_assignment, by="mouse")
#plot
ggplot(data=final, width=.1, aes(x=treatment, y=percentVol))+
  geom_boxplot(alpha=.1,outlier.shape = NA,width=.3,color="grey50")+
  geom_jitter(width=.1,size=2,color="black",alpha=.8)+
  ylab("ss-CBV [%]")+
  scale_x_discrete(limits=c("sham", "ICAO"), labels=c("sham" = "Sham", "ICAO" = "ICAO"))+
  theme_classic()+
  ggtitle("ss-CBV analysis")+
  theme(axis.line = element_line(),
        axis.title = element_text(color="black",size=12),
        axis.text = element_text(color="black",size=11),
        plot.title = element_text(hjust=.5),
        axis.title.x = element_blank())+
  annotate("text",y = 4 ,x=1.5,label = "P = 0.04",size=3.5)




#statistics
t.test(final$percentVol~final$treatment)
