library(tidyverse)
library(readxl)

#group assignment
Group_assignment <- read_excel("data/groups.xlsx",col_names = TRUE)%>%
  rename(name=Mouse)

#histo
histo <- read_excel("data/vesselvol.xlsx")%>%
  inner_join(Group_assignment)%>%
  separate(name,c("Mouse","layer_2"))%>%
  filter(layer!=1,layer!=2,layer!=10)%>%
  rename(group=Names)%>%
  group_by(group,ID,layer_2)%>%
  summarise(volume=median(volume))%>%
  filter(layer_2==3)
  
ggplot(data=histo,aes(x=group, y=volume))+
  geom_boxplot(alpha=.1,outlier.shape = NA,width=.3,color="grey50")+
  geom_jitter(width=.1,size=2,color="black",alpha=.8)+
  scale_x_discrete(limits=c("Sham", "ICAO"))+
  ylab(expression(paste("confocal-CBV")))+
  ggtitle("Histological model validation")+
  theme_classic()+
  theme(axis.line = element_line(),
        axis.title = element_text(color="black",size=12),
        axis.text = element_text(color="black",size=11),
        plot.title = element_text(hjust=.5),
        axis.title.x = element_blank())+
  annotate("text",y = 4.5 ,x=1.5,label = "P = 0.01",size=3.5)

shapiro.test(histo$volume)

t.test(volume~group,data=histo)

histo_sum <- histo%>%
  group_by(group)%>%
  summarise(mean_volume=mean(volume),sd_volume=sd(volume))
