// generate maps for ceAngio protocol

// get names for different scans
if (nImages<4)	exit("There must be at least four images open");

windowNames=newArray(nImages);
// get list of open images
//setBatchMode(true);
for (id=1;id<=nImages;id++) {
	selectImage(id);
	windowNames[id-1]=getTitle();
}

// select images to process
Dialog.create("Generate CE Angio Maps");
Dialog.addChoice("Select T2w", windowNames,windowNames[0]);
Dialog.addToSameRow();
Dialog.addString("Shift in x,y,z in voxels of final resolution", "0,0,0", 8);
Dialog.addChoice("Select TOF Angio", windowNames,windowNames[1]);
Dialog.addToSameRow();
Dialog.addString("Shift in x,y,z in voxels of final resolution", "0,0,0", 8);
Dialog.addChoice("Select CE Angio Pre", windowNames,windowNames[2]);
Dialog.addToSameRow();
Dialog.addString("Shift in x,y,z in voxels of final resolution", "0,0,0", 8);
Dialog.addChoice("Select CE Angio Post", windowNames,windowNames[3]);
Dialog.addToSameRow();
Dialog.addString("Shift in x,y,z in voxels of final resolution", "0,0,0", 8);


Dialog.show();

T2Name=Dialog.getChoice();
shiftT2=split(Dialog.getString(),",");
TOFName=Dialog.getChoice();
shiftTOF=split(Dialog.getString(),",");
CEPreName=Dialog.getChoice();
shiftCEPre=split(Dialog.getString(),",");
shiftCEPre[2]=d2s(-1*parseInt(shiftCEPre[2]),0);
CEPostName=Dialog.getChoice();
shiftCEPost=split(Dialog.getString(),",");
shiftCEPost[2]=d2s(-1*parseInt(shiftCEPost[2]),0);

//debugging
Array.print(shiftT2);
Array.print(shiftTOF);
Array.print(shiftCEPre);
Array.print(shiftCEPost);

// process T2
selectWindow(T2Name);
run("Size...", "width=288 height=288 depth=240 interpolation=Bicubic");
run("Translate...", "x="+shiftT2[0]+" y="+shiftT2[1]+" interpolation=None stack");
temp1=getTitle();
run("Reslice [/]...", "output=0 start=Top avoid");
temp2=getTitle();
run("Translate...", "x=0 y="+shiftT2[2]+" interpolation=None stack");
run("Reslice [/]...", "output=0 start=Top avoid");
rename("t2");
selectWindow(temp1);
close();
selectWindow(temp2);
close();

// process TOF angio
selectWindow(TOFName);
run("Size...", "width=288 height=288 depth=240 interpolation=Bicubic");
run("Translate...", "x="+shiftTOF[0]+" y="+shiftTOF[1]+" interpolation=None stack");
temp1=getTitle();
run("Reslice [/]...", "output=0 start=Top avoid");
temp2=getTitle();
run("Translate...", "x=0 y="+shiftTOF[2]+" interpolation=None stack");
run("Reslice [/]...", "output=0 start=Top avoid");
rename("TOF_Angio");
selectWindow(temp1);
close();
selectWindow(temp2);
close();


// process CE Angio pre
selectWindow(CEPreName);
run("Translate...", "x=0 y="+shiftCEPre[2]+" interpolation=None stack");
run("Reslice [/]...", "output=0 start=Bottom flip avoid");
rename(CEPreName+"_resliced");
CEPreNameResliced=getTitle();
run("Make Substack...", "  slices=9-248");
run("Canvas Size...", "width=288 height=288 position=Top-Center");
makeRectangle(0, 55, 288, 233);
run("Set...", "value=0 stack");
run("Select None");
run("Translate...", "x="+shiftCEPre[0]+" y="+shiftCEPre[1]+" interpolation=None stack");
rename("CE_Angio_Pre");


// process CE Angio post
selectWindow(CEPostName);
run("Translate...", "x=0 y="+shiftCEPost[2]+" interpolation=None stack");
run("Reslice [/]...", "output=0.065 start=Bottom flip avoid");
rename(CEPreName+"_resliced");
CEPostNameResliced=getTitle();
run("Make Substack...", "  slices=9-248");
run("Canvas Size...", "width=288 height=288 position=Top-Center");
makeRectangle(0, 55, 288, 233);
run("Set...", "value=0 stack");
run("Select None");
run("Translate...", "x="+shiftCEPost[0]+" y="+shiftCEPost[1]+" interpolation=None stack");
rename("CE_Angio_Post");

// generate difference image
imageCalculator("Subtract create 32-bit stack", "CE_Angio_Pre","CE_Angio_Post");
rename("CE_Angio_Diff");

// generate BVf map
imageCalculator("Divide create 32-bit stack", "CE_Angio_Pre","CE_Angio_Post");
run("Log", "stack");
run("Multiply...", "value=0.1159 stack");
rename("BVf");
// to avoid problems set NaN to 0
Stack.getDimensions(width, height, channels, slices, frames);
for (s=1;s<=slices;s++) {
	for (f=1;f<=frames;f++) {
		for (c=1;c<=channels;c++) {
			Stack.setPosition(c,s,f);
			for (x=1;x<=width;x++) {
				for (y=1;y<=height;y++) {
					if (getPixel(x,y)==NaN || getPixel(x,y)==1/0) {
						setPixel(x,y,0);
					}
				}
			}
			
		}
	}
}

// generate final Hyperstack with all the results
run("Concatenate...", "  title=CE_Angio_Maps keep open image1=t2 image2=TOF_Angio image3=CE_Angio_Pre image4=CE_Angio_Post image5=CE_Angio_Diff image6=BVf image7=[-- None --]");

// close intermediate windows
selectWindow(CEPreName);
close();
selectWindow(CEPostName);
close();
selectWindow(CEPreNameResliced);
close();
selectWindow(CEPostNameResliced);
close();

// generate t2 for warping
//selectWindow("CE_Angio_Maps");
//run("Reduce Dimensionality...", "slices keep");
//rename("t2");

// generate Hyperstack with 8 bit versions scaled from min to max for visualization
for (i=1;i<=4;i++) {
	selectWindow("CE_Angio_Maps");
	Stack.setPosition(1, 1, i);
	run("Reduce Dimensionality...", "slices keep");
	rename(i);
	Stack.getDimensions(width, height, channels, slices, frames);
	if (slices>1 || frames>1) {
		Stack.getStatistics(voxelCount, mean, min, max, stdDev);
		setMinAndMax(min, max);
	} else {
	resetMinAndMax();
	}
	run("8-bit");
}

for (i=5;i<=6;i++) {
	selectWindow("CE_Angio_Maps");
	Stack.setPosition(1, 1, i);
	run("Reduce Dimensionality...", "slices keep");
	rename(i);
	Stack.getDimensions(width, height, channels, slices, frames);
	if (slices>1 || frames>1) {
		Stack.getStatistics(voxelCount, mean, min, max, stdDev);
		setMinAndMax(0, max);
	} else {
	getStatistics(area, mean, min, max, std, histogram);
	setMinAndMax(0, max);
	}
	run("8-bit");
}

run("Concatenate...", "  title=CE_Angio_Maps_8bit open image1=1 image2=2 image3=3 image4=4 image5=5 image6=6 image7=[-- None --]");
